Prime Path (p3126)

来源:互联网 发布:罗塞塔石碑mac破解版 编辑:程序博客网 时间:2024/05/31 18:36

就是搜索两个四位素数之间的频数。


对四位的每一位都逐步地进行广搜就可以了。


#include<iostream>#include<cstdio>#include<cmath>#include<cstring>#include<string>#include<vector>#include<sstream>#include<algorithm>#include<queue>using namespace std;bool  p[111111];int ans;bool vist[111111];int a,b;struct my{int prime;int s;} go[111111];void bfs(){int head,tail;head=0;tail=1;memset(vist,false,sizeof(vist));vist[a]=true;go[head].prime=a;go[head].s=0;int cur;int num=0;while (head<tail){my d=go[head++];if (d.prime==b){ans=d.s;return; }//cout<<d.prime<<' '<<d.s<<endl;for (int i=1;i<=9;i++){cur=(d.prime/10)*10+i;if (cur!=d.prime && !p[cur] && !vist[cur]){go[tail].prime=cur;go[tail++].s=d.s+1;vist[cur]=true;}}for (int i=0;i<=9;i++){cur=(d.prime/100)*100+d.prime%10+10*i;if (cur!=d.prime && !p[cur] && !vist[cur]){go[tail].prime=cur;go[tail++].s=d.s+1;vist[cur]=true;}}for (int i=0;i<=9;i++){cur=(d.prime/1000)*1000+d.prime%100+100*i;if (cur!=d.prime && !p[cur] && !vist[cur]){go[tail].prime=cur;go[tail++].s=d.s+1;vist[cur]=true;}}for (int i=1;i<=9;i++){cur=d.prime%1000+i*1000;if (cur!=d.prime && !p[cur] && !vist[cur]){go[tail].prime=cur;go[tail++].s=d.s+1;vist[cur]=true;}}//cout<<endl;}}int main(){freopen("c:\in.txt","r",stdin);int i,j,k;int n;memset(p,false,sizeof(p));for (i=2;i<100001;i++) if (!p[i]){for (j=i*2;j<100001;j+=i)p[j]=true;}cin>>n;while (n--){cin>>a>>b;//cout<<n<<endl;bfs();//cout<<n<<endl;cout<<ans<<endl;}return 0 ;}


Prime Path
Time Limit: 1000MS Memory Limit: 65536KTotal Submissions: 8333 Accepted: 4738

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

31033 81791373 80171033 1033

Sample Output

670

Source


原创粉丝点击